"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generate = void 0;
const sdk_1 = require("@prisma/sdk");
const removeDir_1 = __importDefault(require("./utils/removeDir"));
const fs_1 = require("fs");
const transformer_1 = __importDefault(require("./transformer"));
async function generate(options) {
    var _a, _b;
    const outputDir = (0, sdk_1.parseEnvValue)(options.generator.output);
    await fs_1.promises.mkdir(outputDir, { recursive: true });
    await (0, removeDir_1.default)(outputDir, true);
    const prismaClientProvider = options.otherGenerators.find((it) => (0, sdk_1.parseEnvValue)(it.provider) === 'prisma-client-js');
    const prismaClientPath = (0, sdk_1.parseEnvValue)(prismaClientProvider === null || prismaClientProvider === void 0 ? void 0 : prismaClientProvider.output);
    const prismaClientDmmf = (await Promise.resolve().then(() => __importStar(require(prismaClientPath))))
        .dmmf;
    transformer_1.default.setOutputPath(outputDir);
    const enumsObj = new transformer_1.default({
        enumTypes: prismaClientDmmf.schema.enumTypes.prisma,
    });
    await enumsObj.printEnumSchemas();
    for (let i = 0; i < prismaClientDmmf.schema.inputObjectTypes.prisma.length; i += 1) {
        const fields = (_a = prismaClientDmmf.schema.inputObjectTypes.prisma[i]) === null || _a === void 0 ? void 0 : _a.fields;
        const name = (_b = prismaClientDmmf.schema.inputObjectTypes.prisma[i]) === null || _b === void 0 ? void 0 : _b.name;
        const obj = new transformer_1.default({ name, fields });
        await obj.printSchemaObjects();
    }
    const obj = new transformer_1.default({
        modelOperations: prismaClientDmmf.mappings.modelOperations,
    });
    await obj.printModelSchemas();
}
exports.generate = generate;
//# sourceMappingURL=prisma-generator.js.map